<?php
// $Id: views-view-views-jsgantt.tpl.php,v 1.4.2.3 2010/08/31 22:41:31 danepowell Exp $

/**
 * @file
 */

$jsgantt_dir = drupal_get_path('module', 'views_jsgantt');
drupal_add_js($jsgantt_dir . "/jsgantt/jsgantt.js");
drupal_add_css($jsgantt_dir . "/jsgantt/jsgantt.css");
drupal_add_css($jsgantt_dir . "/views_jsgantt.css");
?>
<div style="position:relative" class="gantt" id="GanttChartDIV"></div>
<script language="javascript">
var g = new JSGantt.GanttChart('g',document.getElementById('GanttChartDIV'), '<?php print($options['format']); ?>');
g.setShowRes(0); g.setShowDur(0); g.setShowComp(0); g.setCaptionType('None'); g.setShowStartDate(0); g.setShowEndDate(0);
<?php
$last_group = 0;
$list = array_filter(array_map('trim', explode("\n", $options['colorlist'])), 'strlen');
foreach ($list as $opt) {
  // Sanitize the user input with a permissive filter.
  $opt = content_filter_xss($opt);
  if (strpos($opt, '|') !== FALSE) {
    list($key, $value) = explode('|', $opt);
    $colors[$key] = (isset($value) && $value !=='') ? $value : $key;
  }
  else {
    $colors[$opt] = $opt;
  }
}
foreach ($view->result as $row) {
  $task = array();
  $task['pID'] = is_numeric($row->nid) ? $row->nid : 0;
  $task['pName'] = check_plain($row->$options['tasktitle']);
  $task['pStart'] = date("n/j/Y", strtotime($row->$options['startdate']));
  $task['pEnd'] = $row->$options['enddate'] ? date("n/j/Y", strtotime($row->$options['enddate'])) : '';
  $task['pColor'] = 'ff0000';
  if (!empty($options['colorby'])) {
    $color_key = $row->$options['colorby'];
    if (is_array($colors) && array_key_exists($color_key, $colors)) {
      $task['pColor'] = $colors[$color_key];
    }
  }
  $task['pLink'] = url('node/' . $task['pID']);
  $task['pMile'] = $task['pEnd'] ? 0 : 1;
  $task['pComp'] = 0;
  if (!empty($options['progress'])) {
    if (is_numeric($row->$options['progress'])) {
      $task['pComp'] = $row->$options['progress'];
    }
  }
  $task['pParent'] = 0;
  if (!empty($options['parentid'])) {
    if (is_numeric($row->$options['parentid'])) {
      $task['pParent'] = $row->$options['parentid'];
    }
  }
  $format = "g.AddTaskItem(new JSGantt.TaskItem(%d, '%s', '%s', '%s', '%s', '%s', %d, '%s', %d, %d, %d, 1));\n";
  if ($task['pParent'] != $last_group) {
    // This task has a different parent from the last - add the parent group
    $task['pParentLink'] = url('node/' . $task['pParent']);
    $task['pParentTitle'] = '';
    if (!empty($options['parenttitle'])) {
      $task['pParentTitle'] = check_plain($row->$options['parenttitle']);
    }
    printf($format, $task['pParent'], $task['pParentTitle'], '', '', '', $task['pParentLink'], 0, '', 0, 1, 0);
    $last_group = $task['pParent'];
  }
  printf($format, $task['pID'], $task['pName'], $task['pStart'], $task['pEnd'], $task['pColor'], $task['pLink'], $task['pMile'],'', $task['pComp'],0, $task['pParent']);
}
?>
g.Draw();
g.DrawDependencies();
</script>